// JavaDatagramServer.java

import java.net.*;
import java.nio.*;
import java.nio.channels.*;
import java.io.*;

public class JavaDatagramServer {

	static boolean create_with_nio = false;
	DatagramSocket sock = null;

	public JavaDatagramServer ( boolean create_with_nio, int server_port )
	{
		try
		{
			if (create_with_nio)
				{
				sock = DatagramChannel.open().socket();
				sock.bind(new java.net.InetSocketAddress(server_port));
				System.out.println("Datagram socket created through java.nio");
				}
			else
				{
				sock = new DatagramSocket(server_port);
				System.out.println("Datagram socket created through java.net");
				}
		}
		catch (IOException iox)
			{ System.err.println("Error creating datagram socket" + iox);}
	}

	void read_messages ( )
	{
		byte[] packet_buf = new byte[8000];
		DatagramPacket packet = new DatagramPacket(packet_buf, packet_buf.length);

		while (true)
		{
			try
			{
				System.out.println("Awaiting packets");
				packet.setLength(packet_buf.length);
				sock.receive(packet);
				String message = new String(packet.getData(), 0, packet.getLength());
				String source = null;
				try
				{
					InetAddress address = packet.getAddress();
					source = "('"+address.getHostName()+"',"+packet.getPort()+")";
				}
				catch (NullPointerException npx)
					{ System.out.println("Null pointer exception retrieving address: " + npx);}
				if (source == null)
					try
					{
						InetSocketAddress address = (InetSocketAddress) packet.getSocketAddress();
						source = "('"+address.getHostName()+"',"+address.getPort()+")";
					}
					catch (IllegalArgumentException iax)
						{ System.out.println("Illegal argument exception retrieving socket address: " + iax);}
				if (source == null)
					source = "('Unknown', -1)";
				System.out.println(source+" says '"+message+"'");
			}
			catch (Exception e)
				{ System.out.println(e); }
		}
	}

	static void parse_options ( String[] args )
	{
		for (int ix = 0 ; ix < args.length ; ix++)
			if (args[ix].compareTo("create_nio") == 0)
				create_with_nio = true;
	}

	public static void main(String[] args)
		throws SocketException
	{
		parse_options(args);
		JavaDatagramServer jds = new JavaDatagramServer(create_with_nio, 12000);
		jds.read_messages();
	}
}
/////////////////////////////////////////////////////////////////////////
